/**************************************************************************
*                         CLOCK.H					  *
*       Soucast projektu TUOX                                             *
*       Autori:     Jiri Horacek                L92186                    *
*                   Alan Kornuta                                          *
*                   David Stupnanek                                       *
*       Spoluautor: Jiri Stecker                L94492                    *
*                                                                         *
*                                                                         *
/*************************************************************************/

#ifndef __CLOCK_H_
#define __CLOCK_H_

#include "COMMON\com.h"
#include "clock\h_clock.h"

#define MILLISEC 100                    /* how often to call the scheduler
					   (msec) */
#define SCHED_RATE (MILLISEC*HZ/1000)   /* number of ticks per schedule */

#ifndef ERROR
#define ERROR -1
#endif

#ifndef OK
#define OK 0
#endif

/*========================================================================*
 *                              clock_task                                *
 * Pusti se jenom na zacatku, potom bezi v cyklu a odchytava zpravy.      *
 *========================================================================*/
PUBLIC void clock_task(void);

/*========================================================================*
 *                              clock_stop                                *
 * Nutno volat pred ukoncenim TUOXu - nastavi frekvenci hodin na          *
 * puvodni hodnotu.                                                       *
 *========================================================================*/
PUBLIC void clock_stop(void);

PRIVATE void do_set_alarm(message* m_ptr);
PRIVATE void do_get_time(message * m_ptr);
PRIVATE void do_set_time(message* m_ptr);
PRIVATE void do_clock_tick(void);
PRIVATE void accounting(void);
PRIVATE void init_clock(void);
PUBLIC void clock_stop(void);

#endif /* __CLOCK_H_ */
