
#ifndef __signal_h
#define __signal_h

#define NR_SIGS            16    /* number of signals used */

#define SIGHUP             1    /* hangup */
#define SIGINT             2    /* interrupt (DEL) */
#define SIGQUIT            3    /* quit (ASCII FS) */
#define SIGILL             4    /* illegal instruction */
#define SIGTRAP            5    /* trace trap (not reset when caught) */
#define SIGABRT            6    /* IOT instruction */
#define SIGIOT             6    /* SIGABRT for people who speak PDP-11 */
#define SIGFPE             8    /* floating point exception */
#define SIGKILL            9    /* kill (cannot be caught or ignored) */
#define SIGSEGV           11    /* segmentation violation */      
#define SIGPIPE           13    /* write on a pipe with no one to read it */
#define SIGALRM           14    /* alarm clock */
#define SIGTERM           15    /* software termination signal from kill */

/* Macros used as function pointers. */

#define SIG_ERR    ((sighandler_t) -1)        /* error return */
#define SIG_DFL    ((sighandler_t)  0)        /* default signal handling */
#define SIG_IGN    ((sighandler_t)  1)        /* ignore signal */

#endif
