#ifndef __stat_h
#define __stat_h

struct stat {
  dev_t st_dev;                 /* major/minor device number */
  inode_t st_ino;               /* i-node number */
  mode_t st_mode;               /* file mode, protection bits, etc. */
  link_t st_nlink;              /* # links */
  uid_t st_uid;                 /* uid of the file's owner */
  gid_t st_gid;             	/* gid */
  off_t st_size;                /* file size */
  real_time st_atime;              /* time of last access */
  real_time st_mtime;              /* time of last data modification */
  real_time st_ctime;              /* time of last file status change */
};

#define S_IFMT  ((mode_t) 0170000)      /* type of file */
#define S_IFREG ((mode_t) 0100000)      /* regular */
#define S_IFBLK 0060000         /* block special */
#define S_IFDIR 0040000         /* directory */
#define S_IFCHR 0020000         /* character special */
#define S_ISUID 0004000         /* set user id on execution */
#define S_ISGID 0002000         /* set group id on execution */

#define S_IREAD   04         /* read permission */
#define S_IWRITE  02         /* write permission */
#define S_IEXEC   01         /* exec permission */

#endif

