/************************************************
*	FLOPPY TASK				*
*		Wrtten by:      		*
*			Jiri Kubica		*
*			Libor Cudek	L93360	*
*	Sestava:				*
*		floppy.h     header		*
*		floppy.c     main		*
*		floppy_s.h   header struct	*
*		floppy_d.h   header def		*
*						*
*************************************************/

/* pro kompilaci */

#include "clock\h_clock.h"	/* vyuziva se FUNC, CLOCK_PROC, NEW_TIME */
#include "systask\systask.h"	/* vyuziva se syscopy(...) */
#include "fs\ioctl.h"	/* vyuziva se vyuziva GETDEVSIZE, GETNUMBERMINORDEV */
#include "kernel\makra.h"	/* vyuziva se send(...), recive(...), send_recv(...) */
#include "kernel\klib88.h"

#include "COMMON/com.h"		/* vyuziva se FLOPPY, CLOCK, HARDWARE, SET_ALARM, DISKINT */
#include "COMMON/const.h"	/* vyuziva se PRIVATE, PUBLIC, OK, TRUE, FALSE, HZ, D */
#include "COMMON/type.h"	/* vyuziva se Byte, DWord, vir_bytes, message... */
#include "COMMON/errno.h"	/* vyuziva se EIO, EACCES, EINVAL, ENXIO */

#include "floppy\floppy_d.h"
#include "floppy\floppy_s.h"

PRIVATE void request_motor(void); /* Set clock task for timeout motor off*/
PRIVATE void do_timeout(void);	/* Clock task open this function when timeout */
PRIVATE void floppy_init(void);	/* Initialize floppy structure */
PRIVATE void f_reset(void); /* chyba?? Reset all drives.*/
PRIVATE void f_specify(void);	/* Executes FDC SPECIFY command */
PRIVATE Byte f_open(Byte nr_drive);	/* Open a flopy, execute test (test_read) */
PRIVATE Byte test_read(Byte nr_drive, Byte density);	/* test read highest numbered sector on cylinder 2 */
PRIVATE Byte do_request(struct iorequest_s *iop);	/* execute request rw */
PRIVATE Byte f_schedule(struct iorequest_s *iop);        /* execute read/write */
PRIVATE Byte f_finish(struct trans *tp);		/* end tranaction read/write */
PRIVATE int f_wait(DWord tm_out);	/* wait for result from controller */
PRIVATE Byte start_motor(Byte nr_drive);	/* Start motor */
PRIVATE void stop_motor(Byte nr_drive);	/* Stop motor */
PRIVATE void floppy_stop(void);		/* Shut down controller */
PRIVATE void dma_setup(struct trans *tp);/* perform DMA operations by using the DMA chip */
PRIVATE Byte seek(struct trans * tp);	/* drive positioned on the correct cylinder */
PRIVATE Byte recalibrate(Byte nr_drive);	/* rekalibrate */
PRIVATE Byte read_id(struct trans *tp);  /* Determine current cylinder and sector. */
PRIVATE int f_transfer(struct trans *tp);/* Head is ready on cyl. Do transfer */
PRIVATE Byte fdc_results(void);	/* Extract results from the controller after an operation*/
PRIVATE void fdc_out(Byte val);  /* write this byte to floppy disk controller */
PRIVATE Byte f_intr_wait(void);	/* Wait for an interrupt when read/write */
PRIVATE Byte f_sense_drive(Byte nr_drive);/* Executes FDC SENSE DRIVE STATUS command */
PUBLIC void floppy_task(void);	/* Start clock task */
