/************************************
 * File system group		    *
 * cache.h: header file		    *
 * Miroslav Hastik	l93123	    *
 * mail: Miroslav.Hastik.fei@vsb.cz *
 ************************************/

#ifndef __CACHE_H__
#define __CACHE_H__

#include "fs/cache/buf.h"

PUBLIC void buf_pool(void);

PUBLIC struct buf *get_block(
	register dev_t dev,
	register block_t block,
	int only_search);
/* register dev_t dev;       on which device is the block? */
/* register block_t block;   which block is wanted? */
/* int only_search;          if NO_READ, don't read, else act NORMAL */


PUBLIC void put_block(register struct buf *bp, int block_type);
/* register struct buf *bp;  pointer to the buffer to be released */
/* int block_type;           INODE_BLOCK, DIRECTORY_BLOCK, or whatever */


PUBLIC zone_t alloc_zone(dev_t dev);
/* dev_t dev;                device where zone wanted */
/* zone_t number;            try to allocate new zone near this one */

PUBLIC void free_zone(dev_t dev, zone_t number);
/* dev_t dev;                device where zone located */
/* zone_t number;            zone to be returned */

PUBLIC void invalidate(dev_t dev);
/* dev_t device;             device whose blocks are to be purged */

PUBLIC void flushall(dev_t dev);
/*dev_t dev;                      device to flush */

PUBLIC int sync(void);

#endif
