/* This is the filp table.  It is an intermediary between file descriptors and
 * inodes.  A slot is free if filp_count == 0.
 */

#ifndef __FILE_H
#define __FILE_H
EXTERN struct struct_filp {
  mode_t filp_mode;             /* tells how file is opened-S_IREAD|S_IWRITE */
  int filp_count;               /* how many file descriptors share this slot?*/
  struct inode *filp_ino;       /* pointer to the inode */
  off_t filp_pos;               /* file position */
} filp[NR_FILPS];

#define NIL_FILP (struct struct_filp *) 0      /* indicates absence of a filp slot */
#endif

