/* Tables sizes */
#define NR_ZONE_NUMS       9    /* total # zone numbers in an inode */
#define NR_DZONE_NUM   (NR_ZONE_NUMS-2) /* # direct zone numbers in an inode */
#define NR_BUFS           30    /* # of blocks in the buffer cache */
#define NR_BUF_HASH       32    /* size of the hash table (2^n) */      
#define NR_FDS            20    /* # of file descriptors per process */      

#define NR_FILPS          64    /* # slots in filp table */

#define I_MAP_SLOTS        4    /* max # of blocks in the inode bit map */
                                /* (these maintained in memory together with */
                                /*  the superblock table) */
#define ZMAP_SLOTS         6    /* max # of blocks in the zone bit map */
                                /* (these maintained in memory together with */
                                /*  the superblock table) */


#define NR_INODES         32    /* # slots in memory inode table */
#define NR_SUPERS          3    /* # slots in super block table */
#define NAME_SIZE         14    /* # file name size (directory entry)*/       

#define FS_STACK_BYTES   512    /* size of FS stack */



/* Miscellaneous constants */
#define SUPER_MAGIC   0x137F    /* magic number contained in super-block */
#define SU_UID   ((uid_t) 0)    /* super_user's uid_t */
#define SYS_UID  ((uid_t) 0)    /* uid_t for processes MM and INIT */
#define SYS_GID  ((gid_t) 0)    /* gid_t for processes MM and INIT */

#define NORMAL             0    /* forces get_block to do disk read */
#define NO_READ            1    /* prevents get_block from doing disk read */

#define NO_BIT   ((bit_t) 0)    /* returned by alloc_bit() to signal failure */

#define DUP_MASK        0100    /* mask to distinguish dup2 from dup */

#define LOOK_UP            0    /* tells search_dir to lookup string */
#define ENTER              1    /* tells search_dir to make dir entry */
#define DELETE             2    /* tells search_dir to delete entry */

#define CLEAN              0    /* disk and memory copies identical */
#define DIRTY              1    /* disk and memory copies differ */


#define ROOT_INODE         1    /* inode number for root directory */
#define BOOT_BLOCK  ((block_t) 0)       /* block number of boot block */
#define SUPER_BLOCK ((block_t) 1)       /* block number of super block */

#define ZONE_NUM_SIZE        sizeof (zone_t)           /* # bytes in zone nr */
#define DIR_ENTRY_SIZE       sizeof (struct dir_struct) /* # bytes/dir entry   */
#define INODE_SIZE           sizeof (d_inode)          /* bytes in V1 dsk ino */
#define INODES_PER_BLOCK (BLOCK_SIZE/INODE_SIZE)       /* # inodes/blk */
#define NR_DIR_ENTRIES   (BLOCK_SIZE/DIR_ENTRY_SIZE)  /* # dir entries/blk   */
#define NR_INDIRECTS   (BLOCK_SIZE/ZONE_NUM_SIZE)  /* # zones/indir block */
#define SUPER_SIZE      sizeof (struct super_block)  /* super_block size    */
#define PIPE_SIZE       (NR_DZONE_NUM*BLOCK_SIZE)       /* pipe size in bytes */
#define MAX_ZONES       (NR_DZONE_NR+NR_INDIRECTS+(long)NR_INDIRECTS*NR_INDIRECTS)

#define READING            0    /* copy data to user */
#define WRITING            1    /* copy data from user */

