/* File System global variables. These are filled in the main loop  */
/* when the message is decoded and used elsewhere by subroutines of FS */
#ifndef FSGLOH
#define FSGLOH

#include "common/const.h"

extern struct fproc_struct *fp;        /* pointer to caller's fproc struct */
EXTERN int superuser;           /* 1 if caller is super_user, else 0 */
EXTERN int dont_reply;          /* normally 0; set to 1 to inhibit reply */
EXTERN int susp_count;          /* number of procs suspended on pipe */
EXTERN int reviving;            /* number of pipe processes to be revived */

/* The parameters of the call are kept here. */
EXTERN message fs_msg;          /* the input message itself */
EXTERN message fs_repmsg;       /* the output message used for reply */
EXTERN int who;                 /* caller's proc number */
EXTERN int fs_call;             /* system call number */
EXTERN char user_path[PATH_MAX];/* storage for user path name */

/* The following variables are used for returning results to the caller. */
EXTERN int err_code;            /* temporary storage for error number */

EXTERN int fstack[FS_STACK_BYTES];

#endif
