/*	device.c
 *      v. 1.1
 *	J.Cahlik l92804
 */


/*===========================================================================*
 *                              dev_open                                     *
 *===========================================================================*/
#include "type.h"
#include "device.h"

static message dev_message;

int dev_open(dev_nr dev, int mode) /* ??? k cemu slouzi mode */
{
  int major = 0,minor = 0, task = 0;


  /* inicializace major, minor z dev */
  major = d_minor(dev);	/* (d & 0xFF) */
  minor = d_major(dev);	/* ((d & 0xFF00) >> 8) */

  /* zjisteni tasku pomoci major a dmap[] */
  task = dmap[major].dmap_task;

  /* inicializace struktury message */
  /* ??? struktura message, kam ulozit - minor, status = 0 */
  dev_message.m_source = 01;		/* who sent the message */
  dev_message.m_type = ;	/* what kind of message is it */
  dev_message.m_u.m_m1.m1i1 = 01; 	/* status */
  dev_message.m_u.m_m1.m1i2 = mode;	/* ??? pouze predany parametr */

  /* volani open fce pomoci dmap */
  (*dmap[major].dmap_open)(task,&dev_message);

  return dev_message.m_u.m_m1.m1i1;
}


/*===========================================================================*
 *                              dev_close                                    *
 *===========================================================================*/
void dev_close(dev_nr dev)
{
  int major = 0,minor = 0, task = 0;

  /* inicializace major, minor z dev */
  major = d_minor(dev);	/* (d & 0xFF) */
  minor = d_major(dev);	/* ((d & 0xFF00) >> 8) */


  /* zjisteni tasku pomoci major a dmap[] */
  task = dmap[major].dmap_task;

  /* volani close fce pomoci dmap */
  (*dmap[major].dmap_close)(task);
}

/*===========================================================================*
 *                               dev_io                                      *
 *===========================================================================*/
int dev_io(int rw_flag, dev_nr dev, long pos, int bytes, int proc, char* buf)
{
  int major = 0,minor = 0, task = 0;
  message DISK_RW;

  /* inicializace major, minor z dev */
  major = d_minor(dev);	/* (d & 0xFF) */
  minor = d_major(dev);	/* ((d & 0xFF00) >> 8) */

  /* zjisteni tasku pomoci major a dmap[] */
  task = dmap[major].dmap_task;

  /* inicializace struktury DISK_RW message */
  DISK_RW.m_source = 01;		/* who sent the message */

  /* asi podle rw_flag */
  DISK_RW.m_type = DEV_READ+rw_flag;    /* what kind of message is it */

  DISK_RW.m_u.m_dio.device = minor;
  DISK_RW.m_u.m_dio.proc_nr = proc;
  DISK_RW.m_u.m_dio.count = bytes;
  DISK_RW.m_u.m_dio.position = pos;
  DISK_RW.m_u.m_dio.address = buf; /* POZOR adresa (Word) buf (char*) */

  /* status   ??? kam dat  */


 /* Read/write from a device (dev), (bytes) bytes from (pos) position into
 the address space of (proc) process, where (buf*) points */

 (*dmap[major].dmap_rw)(task,&DISK_RW);
 /* Pokud je status vraceny v message SUSPEND: suspend user process */
 return DISK_RW.status;
}


/*===========================================================================*
 *                               do_ioctl                                    *
 *===========================================================================*/
int do_ioctl()
{
/* ??? Perform the ioctl(fd, request, arg) system call */

/*??? Over platnost descriptoru, najdi pozici ve filp[]
??? Over, ze jde skutecne o specialni (znakovy) soubor
??? Zformuluj zpravu TTY_IOCTL
(*dmap[major].dmap_rw)(task,&mess);
??? Pokud je status SUSPEND: suspend user process
??? Vypln pole odpovedi ve zprave: erase & kill chars, flags*/
  return 0;   /*status*/
}


/*===========================================================================*
			      Mozne pomocne funkce:

find_dev(dev_nr dev)
 - rozlozi dev na major a minor cislo a cislo odpovidajiciho tasku,
   ulozi do globalnich promennych

rw_dev(int task_nr, message* msg)
 - na tuto funkci je nasmerovano dmap[].dmap_rw
 sendrec(task_nr,msg)
? Over, ze odpoved patri pozadavku (podle cisla procesu)
? Pokud jsme dostali odpoved na drivejsi zadost: obsluz a znovu receive
  revive(proc_nr z receive), receive()

? rw_dev2(int task_nr, message* msg)
 - volano pro ridici terminal. Jako rw_dev, ale nepouziji se zadana major
   a minor cisla, ale vyctou z fproc[].fs_tty. Pak vola rw_dev()

no_call()
 - prazdna funkce, vzdy v message result vraci OK
*/

