/* This file contains a collection of miscellaneous procedures.  Some of them
 * perform simple system calls.  Some others do a little part of system calls
 * that are mostly performed by the Memory Manager.
 *
 * The entry points into this file are
 *   do_dup:      perform the DUP system call
 *   do_sync:     perform the SYNC system call
 *   do_fork:     adjust the tables after MM has performed a FORK system call
 *   do_exit:     a process has exited; note that in the tables
 *   do_set:      set uid or gid for some process
 *   do_revive:   revive a process that was waiting for something (TTY or pipe)
 */

/*===========================================================================*
 *                              do_dup                                       *
 *===========================================================================*/
PUBLIC int do_dup();

/*===========================================================================*
 *                              do_sync                                      *
 *===========================================================================*/
PUBLIC int do_sync();

/*===========================================================================*
 *                              do_fork                                      *
 *===========================================================================*/
PUBLIC int do_fork();

/*===========================================================================*
 *                              do_exit                                      *
 *===========================================================================*/
PUBLIC int do_exit();

/*===========================================================================*
 *                              do_set                                       *
 *===========================================================================*/
PUBLIC int do_set();

/*===========================================================================*
 *                              do_revive                                    *
 *===========================================================================*/
PUBLIC int do_revive();
