            /**********************************************\
            **                                            **
            **  TUOX                                      **
            **                                            **
            **  File System - STADIR.H                    **
            **                                            **
	    **  Stanislav Sikora, L92053                  **
            **  Prepracoval David Spalt, L94607		  **
            **                                            **
            \**********************************************/

/**************************************************************************\
**  int do_chdir()      zmena adresare                                    **
**  int do_chroot()     zmena korenoveho adresare                         **
**  int do_stat()       vyplnuje struct stat podle jmena souboru          **
**  int do_fstat()      vyplnuje struct stat podle cisla inodu            **
**  int stat_inode()    vyplnuje struct stat podle file descriptor-u      **
**                      volana do_stat() a do_fstat()                     **
**  int change()        meni adresar                                      **
**                      volana do_chdir() a do_chroot()                   **
\**************************************************************************/

#include "fs/common/fsconst.h"
#include "common/const.h"
#include "fs/common/fproc.h"
#include "fs/common/file.h"

#include "fs/inode/inode.h"


PUBLIC int do_setuid();
/*zmeni uid u nejakeho proc v nasi tabulce procesu*/
PUBLIC int do_setgid();
/*zmeni gid u nejakeho proc v nasi tabulce procesu*/

/**************************************************************************\
**                                                                        **
**  int do_chdir()      zmena adresare                                    **
**                                                                        **
****************************************************************************
**                                                                        **
**  vstup:  m_type	C_CHDIR                                           **
**          fs_name     pointer na nazev adresare                         **
**                                                                        **
**  vystup: fs_errcode	chybovy kod                                       **
**                                                                        **
\**************************************************************************/
EXTERN int do_chdir();


/**************************************************************************\
**                                                                        **
**  int do_chroot()     zmena korenoveho adresare                         **
**                                                                        **
****************************************************************************
**                                                                        **
**  vstup:  m_type	C_CHROOT                                          **
**          fs_name     pointer na nazev adresare                         **
**                                                                        **
**  vystup: fs_errcode  chybovy kod                                       **
**                                                                        **
\**************************************************************************/
EXTERN int do_chroot();


/**************************************************************************\
**                                                                        **
**  int do_stat()       vyplnuje struct stat podle jmena souboru          **
**                                                                        **
****************************************************************************
**                                                                        **
**  vstup:  m_type	C_STAT                                            **
**          fs_name     pointer na nazev adresare                         **
**          fs_buff     pointer na vyst bufer (struct stat)               **
**                                                                        **
**  vystup: ENOENT      spatny nazev                                      **
**          return rw_user()                                              **
**                                                                        **
\**************************************************************************/
EXTERN int do_stat();


/**************************************************************************\
**                                                                        **
**  int do_fstat()      vyplnuje struct stat podle cisla inodu            **
**                                                                        **
****************************************************************************
**                                                                        **
**  vstup:  m_type	C_FSTAT                                           **
**          fs_fd       file descriptor                                   **
**          fs_buffer   pointer na vyst bufer (struct stat)               **
**                                                                        **
**  vystup: return rw_user()                                              **
**                                                                        **
\**************************************************************************/
EXTERN int do_fstat();

