            /**********************************************\
            **                                            **
            **  TUOX                                      **
            **                                            **
            **  File System - TIME.H                      **
            **                                            **
	    **  Stanislav Sikora, L92053                  **
            **  Prepracoval David Spalt, L94607		  **
            **                                            **
            \**********************************************/

/**************************************************************************\
**  int do_utime()      meni cas v souboru                                **
**  int do_time()       zjistuje aktualni cas                             **
**  int do_stime()      nastavuje cas                                     **
**  int do_tims()       zjistuje casy procesu                             **
\**************************************************************************/

#include "common/const.h"
#include "fs/common/fsconst.h"
#include "fs/common/fproc.h"
#include "fs/common/file.h"

#include "fs/inode/inode.h"

/**************************************************************************\
**                                                                        **
**  int do_utime()      meni cas v souboru                                **
**                                                                        **
****************************************************************************
**                                                                        **
**  vstup:  m_type	C_UTIME                                                **
**          fs_namet    pointer na nazev souboru                          **
**          fs_timep    novy cas                                          **
**                                                                        **
**  vystup: ENOENT      spatny nazev                                      **
**          EACCES      zmenu casu souboru nelze provest                  **
**          OK          zmena casu uspesne provedena                      **
**                                                                        **
\**************************************************************************/
PUBLIC int do_utime();


/**************************************************************************\
**                                                                        **
**  int do_time()       zjistuje aktualni cas                             **
**                                                                        **
****************************************************************************
**                                                                        **
**  vstup:  m_type	C_TIME                                            **
**          fs_tp       pointer na vyst promennou typu real_time          **
**                                                                        **
**  vystup: return rw_user()                                              **
**                                                                        **
\**************************************************************************/
PUBLIC int do_time();


/**************************************************************************\
**                                                                        **
**  int do_stime()      nastavuje cas                                     **
**                                                                        **
****************************************************************************
**                                                                        **
**  vstup:  m_type	C_STIME                                           **
**          fs_tp       pointer na vstup promennou typu real_time         **
**                                                                        **
**  vystup: return rw_user() nebo return send_recv(CLOCK,mm)              **
**                                                                        **
\**************************************************************************/
PUBLIC int do_stime();


/**************************************************************************\
**                                                                        **
**  int do_tims()       zjistuje casy procesu                             **
**                                                                        **
****************************************************************************
**                                                                        **
**  vstup:  m_type	C_TIMES                                           **
**          fs_buffer   pointer na vyst bufer (pole) typu real_time       **
**                                                                        **
**  vystup: return rw_user()                                              **
**                                                                        **
\**************************************************************************/
PUBLIC int do_tims();
