/****************************************************************************/
/*                         TUOX kernel: modul MAKRA.H                       */
/****************************************************************************/


#ifndef __MAKRA_H_
#define __MAKRA_H_

/* Dulezite pro BOOT: jako sluzba OS bylo zvoleno preruseni INT 31h */

/* Konstanty predstavujici jednotlive sluzby jadra OS (INT 31h) */

/* !!! NESMI SE PREHAZOVAT !!! */
#define SEND     1
#define RECEIVE  2
#define BOTH     3  /* send & receive */
#define TRAP     4
#define DIE_TRAP 8

/* Zpravy pro makra musi byt globalnimi promennymi prislusnych modulu.     */
/* Bude nejlepsi, kdyz viditelnost techto zprav bude omezena modifikatorem */
/* static. A ted pozor! Makra se nebudou volat stylem receive(x,&m), ale   */
/* receive(x,m)! Struktura se zpravou nesmi byt lokalni!                   */

/* sendera neni treba vyplnovat */
#define send(addressee,mp) \
asm { \
  mov ax,SEND; \
  mov bx,(addressee); \
  mov dx,offset mp; \
  int 31h; \
};

#define trap(errnr) \
asm { \
  mov ax,TRAP; \
  mov bx,(errnr); \
  int 31h; \
}

#define die_trap(errnr) \
asm { \
  mov ax,DIE_TRAP; \
  mov bx,(errnr); \
  int 31h; \
};

#define receive(sender,mp) \
asm { \
  mov ax,RECEIVE; \
  mov bx,(sender); \
  mov dx,offset mp; \
  int 31h; \
};

#define send_recv(process,mp) \
asm { \
  mov ax,BOTH ; \
  mov bx,(process); \
  mov dx,offset mp; \
  int 31h; \
};


#endif /* __MAKRA_H_ */
