/****************************************************************************/
/*                         TUOX kernel: modul PROC.H                        */
/****************************************************************************/


#ifndef __PROC_H_
#define __PROC_H_

#include "COMMON\com.h"

#include "kernel\proc_pub.h"
#include "kernel\makra.h"

#ifndef EXTERN
  #define EXTERN extern
  #define EXTERN_OVERRIDE
#endif


EXTERN struct proc *rdy_head[NQ]; /* pointer to array of headers of ready lists  */
EXTERN struct proc *rdy_tail[NQ]; /* pointer to array of headers of ready tails  */
/* EXTERN struct proc *pproc_addr[NR_TASKS + NR_PROCS]; */
  /* ptrs to process table slots; fast because now a process entry can be found
     by indexing the pproc_addr array, while accessing an element i requires
     a multiplication with sizeof(struct proc) to determine the address */
extern message int_mess;
#define TASK_Q         0    /* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
#define SERVER_Q       1    /* !!! Tyto konstanty nemenit !!! */
#define USER_Q         2    /* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */

#define POC_BITU_PRER 65          /*   64+1   */
 // P.G.: zvetseno, protoze pribyl HDD task


/* Definice chybovych kodu */
#define E_BAD_SRC  -1     /* Error bad source */
#define E_BAD_DEST -2     /* Error bad destination */
#define E_NO_PERM  -3     /* Error no permition */
#define E_LOCKED   -4     /* Error locked */
#define E_OVERRUN  -5     /* Error overrun */


/* ===== UVNITR PROC.C NALEZNETE: ===== */

PRIVATE unsigned TasknrToTaskbit(int task_nr);
PRIVATE int TaskbitToTasknr(unsigned task_bit);

PUBLIC int mini_send(int caller, int dest, message *m_ptr);
PRIVATE int mini_rec(int caller, int src, message *m_ptr);

void k_save(void);
void k_restore(void);
void k_restart(void);

#ifdef EXTERN_OVERRIDE
  #undef EXTERN_OVERRIDE
  #undef EXTERN
#endif


#endif /* __PROC_H_ */
