/*********************************************************
 *               Hlavickove soubory pro TUOX             *
 *                                                       *
 * Soubor:    ctype.h                                    *
 * Popis:     Definice znakovych maker                   *
 *                                                       *
 * Autori:    Rostislav Bosak                            *
 *            Jaroslav Hurdes                            *
 *            Martin Perina                              *
 *            Martin Vojvodik                            *
 *							 *
 * Prepracov: Daniel Tvrdy				 *
 *            Ivo Orlik				(c) 1997 *
 *********************************************************/

#ifndef _CTYPE_H_

#define _CTYPE_H_

#define _IS_SP  1           /* mezera */
#define _IS_DIG 2           /* cislo */
#define _IS_UPP 4           /* velke pismeno */
#define _IS_LOW 8           /* male pismeno */
#define _IS_HEX 16          /* [0..9] or [A-F] or [a-f] */
#define _IS_CTL 32          /* control */
#define _IS_PUN 64          /* oddelovac */

extern char cdecl _ctype[];    /* pole pro typ znaku */

int cdecl isalnum (int __c);
int cdecl isalpha (int __c);
int cdecl isascii (int __c);
int cdecl iscntrl (int __c);
int cdecl isdigit (int __c);
int cdecl isgraph (int __c);
int cdecl islower (int __c);
int cdecl isprint (int __c);
int cdecl ispunct (int __c);
int cdecl isspace (int __c);
int cdecl isupper (int __c);
int cdecl isxdigit (int __c);
int cdecl tolower  (int __c);
int cdecl toupper  (int __c);


#define _isalnum(c)  (_ctype[(c) + 1] & (_IS_DIG | _IS_UPP | _IS_LOW))
#define _isalpha(c)  (_ctype[(c) + 1] & (_IS_UPP | _IS_LOW))
#define _isascii(c)  ((unsigned)(c) < 128)
#define _iscntrl(c)  (_ctype[(c) + 1] & _IS_CTL)
#define _isdigit(c)  (_ctype[(c) + 1] & _IS_DIG)
#define _isgraph(c)  ((c) >= 0x21 && (c) <= 0x7e)
#define _islower(c)  (_ctype[(c) + 1] & _IS_LOW)
#define _isprint(c)  ((c) >= 0x20 && (c) <= 0x7e)
#define _ispunct(c)  (_ctype[(c) + 1] & _IS_PUN)
#define _isspace(c)  (_ctype[(c) + 1] & _IS_SP)
#define _isupper(c)  (_ctype[(c) + 1] & _IS_UPP)
#define _isxdigit(c) (_ctype[(c) + 1] & (_IS_DIG | _IS_HEX))

#define _toupper(c) ((c) + 'A' - 'a')
#define _tolower(c) ((c) + 'a' - 'A')

#endif