/*********************************************************
 *               Hlavickove soubory pro TUOX             *
 *                                                       *
 * Soubor:    dir.h                                      *
 * Popis:     Definice funkci pro praci se soubory       *
 *                                                       *
 * Autori:    Rostislav Bosak                            *
 *            Jaroslav Hurdes                            *
 *            Martin Perina                              *
 *            Martin Vojvodik                            *
 *							 *
 * Prepracov: Daniel Tvrdy				 *
 *            Ivo Orlik				(c) 1997 *
 *********************************************************/

#if !defined(__DIR_H)
#define __DIR_H

#include "common\type.h"
#include "fs\common\fstype.h"

struct  ffblk   {
    inode_t   ff_inode;
    char      ff_name[NAME_SIZE];
};

#define MAXPATH   80
#define MAXDIR    66
#define MAXFILE   NAME_SIZE

/* !!! parametry nekterych funkci nemusi byt definitivni !!! */


int  access (const char *_path, int _mode);
int  chdir (const char *_path);
int  chmod (const char *_path, int _mode); 
int  chown (const char *_path, int _uid, int _gid);
int  chroot (const char *_newroot);
int  close (int _handle);
int  creat (const char *_path, int _mode);
int  fstat (int _handle, struct stat *_buffer);
int  link (const char *_path, const char *_link);
int  lseek (int _handle, int _offset, int _whence);
int  mknod (const char *_specf, int _mode, int _addr);
int  open (const char *_path, int _mode);
int  read (int _handle, void *_buf, unsigned _len);
int  stat (const char *_path, struct stat *_buffer);
int  stime (char *_tp);
long time (long *_tp);
int  tims (long *_buf);
unsigned int umask (unsigned int _mode);
int  unlink (const char *_link);
/* int  utime (const char *_path, struct utimbuf timep); */
/*int write (int _handle, void *_buf, unsigned _len, int _seg); */
int write (int _handle, void *_buf, unsigned _len);

int mount (const char *_specf, const char *_path, int _readonly);
int umount (const char *_specf);



#endif  /* __DIR_H */

