/*********************************************************
 *               Hlavickove soubory pro TUOX             *
 *                                                       *
 * Soubor:    process.h                                  *
 * Popis:     Definice funkci pro praci s procesy        *
 *                                                       *
 * Autori:    Rostislav Bosak                            *
 *            Jaroslav Hurdes                            *
 *            Martin Perina                              *
 *            Martin Vojvodik                            *
 *							 *
 * Prepracov: Daniel Tvrdy				 *
 *            Ivo Orlik				(c) 1997 *
 *********************************************************/

#ifndef __PROCESS_H
#define __PROCESS_H
/*
#ifndef NULL
#define NULL    0
#endif
*/
#include "COMMON\type.h"

#define __ERR_STACK_SIZE  -201
#define __EXEC_STACK_SIZE 1024

/* #define __MPROCCOPY MM_MPROCCOPY */
/* #define __MPROCSIZE MM_MPROCSIZE */


/* ukonci proces, navratova hodnota status */
void _exit (int status);

/* posune hranici gapu */
void *  brk (int __incr);

/* pocka na ukonceni vsech child procesu */
int     wait(void);

/* pocka na ukonceni procesu se zadanym pid */
int     waitpid (pid_t __pid, int __options);

/* nastavi spusteni alarmu na cas, ktery nastane po uplynuti zadaneho
   poctu sekund */
int     alarm (int __seconds);

/* */
int     pause();

/* rozdeli proces na dva totozne, startujici prikazem nasledujicim za fork() */
pid_t   fork();

/* ukonci proces se zadanym pid */
int     kill (pid_t __pid, int __sig);


/* vrati pid volajiciho procesu */
pid_t   getpid(void);

/* ulozi do __ruid a __euid skutecne a efektivni UID procesu __pid */
uid_t   getuid (pid_t __pid, uid_t *__ruid, uid_t *__euid);

/* ulozi do __rgid a __egid skutecne a efektivni GID procesu __pid */
gid_t   getgid (pid_t __pid, gid_t *__rgid, gid_t *__egid);

/* nastavi efektivni UID procesu __pid na __uid, vyzaduje prava SUPER_USER */
int     setuid (uid_t __uid);

/* nastavi efektivni GID procesu __pid na __uid, vyzaduje prava SUPER_USER */
int     setgid (gid_t __gid);

/* vrati GROUP procesu __pid */
int     getpgrp (pid_t __pid);

/* nastavi GROUP procesu __pid na __group, vyzaduje prava SUPER_USER */
int     setpgrp (pid_t __pid, int __group);

/* opt = __MPROCCOPY
    zkopiruje tabulku procesu m_proc do mista daneho ukazatelem __where
    (misto musi byt v datovem segmentu volajiciho procesu (staticky
    alokovano)).
   opt = __MPROCSIZE
    vrati pouze velikost, nekopiruje
   Vraci velikost tabulky MPROC */
int     getmproc (void *__where, int __opt);

/* spusti proces predstavovany programem danym __path s argumenty __args a
   s nepristupnym environmentem __env = NULL */
int     execv(const char *__path, char *__args[]);

/* spusti proces predstavovany programem danym __path s argumenty __args a
   s environmentem __env */
int     execve(const char *__path, char *__args[], char *__env[]);

/* nastavi signal, pokud func == NULL, pak nastavi signal IGNORE */
void cdecl (* cdecl signal(int __sig, void cdecl (* func)())) (int);




#endif