/*
 ****************************************************************************
 * soubor: getmproc.c                                                       *
 * autor:  Marcel Kruzel, Zdenek Sawa, Milan Gvozdik                        *
 * ladici: Rojicek Radim, Sela Jaroslav                                     *
 ****************************************************************************
*/

#include "COMMON\type.h"
#include "COMMON\com.h"
#include "COMMON\const.h"

#include "kernel\makra.h"
#include "systask\syst_pub.h"

#include "mm\mm.h"
#include "mm\getmproc.h"
#include "mm\mm_glob.h"
#include "mm\mmerror.h"

PUBLIC int do_getmproc()
{
  if (mm_in.MM_GETMPROCOPT==MPROCSIZE) 
  {
//    mm_out.MM_GETMPROCSIZE=NR_PROCS*sizeof(struct mproc);
    mm_out.MM_GETMPROCSIZE=NR_PROCS+NR_TASKS+NR_SERVS*sizeof(struct mproc);
    return OK;
  } else
  if (mm_in.MM_GETMPROCOPT==MPROCCPY)
  {    
/* kopirovani bloku pameti */    
    mm_out.SRC_SEG=D;
    mm_out.SRC_PROC=MM;
    mm_out.SRC_VIR=((unsigned int)&mproc);
    mm_out.DST_SEG=D;
    mm_out.DST_PROC=who;
    mm_out.DST_VIR=(unsigned int)mm_in.MM_GETMPROCPTR;
//    mm_out.BYTE_CNT=NR_PROCS*sizeof(struct mproc);
    mm_out.BYTE_CNT=NR_PROCS+NR_TASKS+NR_SERVS*sizeof(struct mproc);
    mm_out.m_type=SYS_COPY;
    send_recv(SYSTASK,mm_out);
    return OK;
  } else return EINVAL;
}