/*
 ****************************************************************************
 * soubor: mm.h                                                             *
 * autor:  Marcel Kruzel, Zdenek Sawa, Milan Gvozdik                        *
 * ladici: Rojicek Radim, Sela Jaroslav                                     *
 ****************************************************************************
*/

#ifndef MM_H_
#define MM_H_

/* Interface Funkci Memory manageru */
#define MM_ERRORNO      m1_i1

#define MM_EXITSTATUS   m1_i1
#define MM_FORKEDCHILD  m1_i2

#define MM_WAITFOR      m1_i1
#define MM_WAITOPT      m1_i2
#define WNOHANG 	1

#define MM_EXITVALUE    m1_i2 
#define MM_EXITEDPID    m1_i3

#define MM_BRKINCR      m1_i1
#define MM_BRKADDR      m1_p1

#define MM_EXECFNAME    m1_p2 
#define MM_PATHSIZE     m1_i2
#define MM_EXECSTACK    m1_p1
#define MM_EXECSIZE     m1_i1

/* Get ID */
#define MM_GETIDPID     m1_i1
#define MM_GRUID        m1_i2
#define MM_GEUID        m1_i3
#define MM_GRGID        m1_i2
#define MM_GEGID        m1_i3

/* Get PID */
#define MM_GPID         m1_i2
#define MM_GPPID        m1_i3

/* Set ID */
#define MM_SUID         m1_i1
#define MM_SGID         m1_i1

/* Set Pgrp */
#define MM_SPGRPPID     m1_i1
#define MM_SPGRPVALUE   m1_i2

/* Get Pgrp */
#define MM_GPGRPPID     m1_i1
#define MM_PGRP         m1_i2

/* GETMPROC */
#define MM_GETMPROCPTR  m1_p1
#define MM_GETMPROCOPT  m1_i1 
#define MPROCCPY        01
#define MPROCSIZE       02

#define MM_GETMPROCSIZE m1_i2

/*makra pro signaly*/
#define MM_SIGNAL       m6_i1 /*cislo signalu*/
#define MM_PTRFUNC      m6_f1 /*ukazatel na uzivatelskou fci nebo vlajka SIG_IGN | SIG_DFL*/
#define MM_PID          m6_i2 /*ID procesu*/
#define MM_ALARMSECOND  m6_i1 /*pocet sekund do alarmu*/
#define MM_SIGBMP       m6_i1 /*bitmapa signalu*/

#endif