/*
 ****************************************************************************
 * soubor: mmerror.h                                                        *
 * autor:  Marcel Kruzel, Zdenek Sawa, Milan Gvozdik                        *
 * ladici: Rojicek Radim, Sela Jaroslav                                     *
 ****************************************************************************
*/

#ifndef MMERROR_H
#define MMERROR_H

#include "COMMON\errno.h"

/* Exec */
#define ErrBadStack           EACCES
#define ErrMissingFilename    ENOENT
#define ErrNotExecutable      ENOEXEC
#define ErrTextSizeTooBig     EACCES
#define ErrDataSizeTooBig     EACCES
#define ErrBssSizeTooBig      EACCES
#define ErrDataBssSizeTooBig  EACCES
#define ErrTotalSizeTooBig    EACCES
#define ErrNotStackPlace      EACCES

/* Break */
#define EBREAK ENOMEM /* snaha zmenit heanici mimo moznou oblast */

/*  Wait */
#define ErrChildStillAlive    ECHALIVE /* 301 Dite porad aktivni (pri wait s options==WNOHANG) */

/* Get,Set ID , PGRP ..*/              
#define ENORIGHTS             EPERM /* Nedostatecne pravomoci  */
#define EInvalidPID           ESRCH /* Takovy proces neexistuje */

/* GeTMPROC */
/* #define ESHORTMEM 	      450 */


/* SIGNALY */
#define ErrSigOutRange        EINVAL /* cislo signalu je mimo platny rozsah*/
#define ErrProcNotFind        ESRCH /* proces, kteremu byl zaslan signal nebyl nalezen*/

#define ErrProcNotUse         ESRCH  /* proces neni IN_USE */
#define ErrProcNotFSorKERNEL  EPERM  /* proces posilajici zpravu neni FS nebo Kernel*/

#endif