/* Helper Functions to Call FS Services (used in MM) */

/* used exclusively in mm/exec.c */

#include "COMMON\type.h"

// Vsechny funkce vraci chybu, ktera se predava knihovnam (nebo 0 pokud OK)

int test_exec(char* filename);
 /*
  Overi, zda je soubor za daneho euid/egid spustitelny.
  vstup: ptr na jmeno souvoru
  vraci: 0=OK, jinak err code
   (vraci z do_exec() a stava se z nej errno zpravy C_EXEC)
 */

int open_file(char* filename, int* fd);
/*
  Pokusi se otevrit soubor filename, ve fd vrati file descriptor.
  Vraci: 0=OK, jinak errcode, ktere se vraci z do_exec() a nasledne z C_EXEC
*/

int close_file(int fd);
/*
  Zavre soubor fd. Pouziti do_exec(). Vraci: 0=OK, jinak chyba, ktera se
  zatim v tichosti ignoruje; casem by se mohla vracet z do_exec()
  do errno C_EXEC
*/

int read_file_mm(int fd, char*  buf, int len, procnr_t toProc, int seg);
/*
  Ze souboru s descriptorem fd precte len bajtu na adresu buf do procesu
  toProc, segmentu seg.
  Vraci pocet nactenych bajtu nebo kod chyby (COMMON/errno.h,<0) - z C_READ)
*/

int get_setuid(char* filename, int* bit);
 /* zjisteni hodnoty SUID bitu souboru. Vraci: 0=OK, jinak chyba
    z FS:rw_user() */

int get_setgid(char* filename, int* bit);
 /* zjisteni hodnoty SGID bitu souboru. Vraci: 0=OK, jinak chyba
    z FS:rw_user() */

int get_file_owner(char* filename, uid_t* owner);
 /* zjisteni vlastnika souboru (owner uid). Vraci: 0=OK, jinak chyba
    z FS:rw_user() */

int get_file_owner_g(char* filename, gid_t* owner_g);
 /* zjisteni skupiny vlastnika souboru (owner gid). Vraci: 0=OK, jinak chyba
    z FS:rw_user() */

#include "mm/mm2fsmsg.h"

#define fs_parent 	m1_i1 /* FORK */
#define fs_child 	m1_i2
#define fs_proc		m1_i1 /* EXIT */