#include "test.cnf"

#if ((EXECINMEM_SIZE!=0) || (FSINMEM_SIZE!=0))

#include "COMMON/type.h"
#define ERR_COUNT_TOO_BIG	(-100)

int openFileDOS(char* fName) {
// vraci: handle (kladne cislo), jinak error kod
 int result;

 asm mov ah,0x3d /* open file */
 asm mov dx, fName /* ds:dx: ptr na filename */
 asm mov al,0 /* open for reading */
 asm int 0x21
 asm mov result,ax
 asm jc open_err

 asm jmp open_end
open_err:
 result*=-1;

open_end:
 return result;
}

int closeFileDOS(int handle) {
 // vraci: 0=OK, jinak error code (zaporne)
 int result=0;

 asm mov ah,0x3e /* close file */
 asm mov bx, handle
 asm int 0x21
 asm jc close_err

 return 0;

close_err:
 asm mov result,ax
 result*=-1;
 return result;
}



int readFileDOSex(int handle, char* buf, Word segm, Word count, int* errNo) {
 // vraci: pocet prectenych bytes nebo -1 pri chybe (pak nastavi errNo)
 // count je maximalne 65534 (aby se nepletlo s -1)

 int result=0;

 if (count>65534) { *errNo=ERR_COUNT_TOO_BIG; return -1; }

 asm push ds
 asm mov ax, segm
 asm mov ds,ax
 asm mov ah,0x3f /* read file */
 asm mov bx,handle
 asm mov dx, buf /* DS:DX - buffer */
 asm mov cx,count
 asm int 0x21
 asm jc read_err
 asm pop ds
 asm mov result,ax
 *errNo=0;
 return result;

read_err:
 asm pop ds
 asm mov result,ax
 *errNo=result*(-1);
 return -1;
}

int readFileDOS(int handle, char* buf, Word count, int* errNo) {
 // vraci: pocet prectenych bytes nebo -1 pri chybe (pak nastavi errNo)
 // count je maximalne 65534 (aby se nepletlo s -1)

 int result=0;

 if (count>65534) { *errNo=ERR_COUNT_TOO_BIG; return -1; }

 asm mov ah,0x3f /* read file */
 asm mov bx,handle
 asm mov dx, buf /* DS:DX - buffer */
 asm mov cx,count
 asm int 0x21
 asm jc read_err
 asm mov result,ax
 *errNo=0;
 return result;

read_err:
 asm mov result,ax
 *errNo=result*(-1);
 return -1;
}

int seekFileDOS(int handle, unsigned long pos) {
 // vraci: 0=OK, jinak error code (zaporne)
 int result=0;

 asm mov ah,0x42 /* lseek */
 asm mov bx, handle
 asm mov cx,word ptr pos /* cx:dx - pos */
 asm mov dx,word ptr (pos+2)
 asm mov al,0 /* from start */
 asm int 0x21
 asm jc seek_err

 return 0;

seek_err:
 asm mov result,ax
 result*=-1;
 return result;
}

void dosExit(Byte exitCode) {
 asm {
  mov ah,4ch
  mov al,exitCode
  int 21h
 }
}

#endif