#include "kernel\proc_pub.h"
#include "tty\scancode.h" // z TTY driveru
#include "test\kprintf.h" // z TTY driveru

void obnovInterrupty(void); // z KMAIN.C

void returnToDOS(void) {
 kprintf(24,0,7,"Returning to DOS...                                 ");
 obnovInterrupty();
 asm sti
 asm mov ax,0x4c00 /* terminate TUOX debugging kernel, returning to DOS */
 asm int 0x21

}

void interrupt tty_exitor(void) {
 // int09 heyboard handler. Test if an exit key (END) pressed
 // and if it was, terminate the program, restoring original interrupts
 // first. Since we don't use DOS calls in TUUOX code at all, we needn't
 // worry about DOS reentrancy and simply call DOS fn 4ch (terminate) from
 // interrupt handler (sending EOI and enabling interupts first).

 /* EOI na 8259 */

 asm mov dx,0x20
 asm mov al,0x20
 asm out dx,al

 /* precteni scancodu z portu do bl */
 asm in   al, 0x60
 asm mov  bl, al
 asm mov  dx, 0x61
 asm in   al, dx
 asm mov  ah, al
 asm or   al, 0x80
 asm out  dx, al
 asm xchg al, ah
 asm out  dx, al

 asm test bl, BREAK_CODE
 asm jnz nothing /* key released */

 asm cmp bl,sc_End
 asm jne nothing

 returnToDOS();

 nothing:
 /* pop all and iret follows */
}

