#include <stdarg.h>

#define MK_FP( seg,ofs )( (void _seg * )( seg ) +( void near * )( ofs ))



void writeOneChar(unsigned char row, unsigned char col, unsigned char attr, char aChar)
 {
  char far* pos=(char far*) MK_FP(0xb800,row*80*2+col*2);
  *pos=aChar; *(pos+1)=attr;
 }

static void writeChar(char aChar,
  unsigned char *curRow, unsigned char *curCol, unsigned char *curAttr) {
 writeOneChar(*curRow, *curCol, *curAttr, aChar);
 (*curCol)++;
 if (*curCol>79) { (*curRow)++; *curCol=0; }
 if (*curRow>24) { *curRow=0; }
}

static void writeDecLong(unsigned long l,
 unsigned char *curRow, unsigned char *curCol, unsigned char *curAttr) {
 char digit[15]; // nemelo by byt vice nez 4 G)
 int i=0,d;

 if (l==0L) writeChar('0',curRow,curCol,curAttr);
  else {
   while (l>0) {
    d=l % 10;
    l=l/10;
    digit[i++]=d+'0';
   }
   i--;
   while (i>=0) writeChar(digit[i--],curRow,curCol,curAttr);
  }
}

#define MAXINT     0x7FFFL
static void writeSignedDecInt(int i,
  unsigned char *curRow, unsigned char *curCol, unsigned char *curAttr) {
 unsigned int ui;

  ui=(unsigned int) i;
 if (ui>MAXINT) {
  ui=~ui;
  ui++;
  writeChar('-',curRow,curCol,curAttr);
  writeDecLong(ui,curRow,curCol,curAttr);
 } else writeDecLong(ui,curRow,curCol,curAttr);
}

static void writeHexInt(unsigned int x,
  unsigned char *curRow, unsigned char *curCol, unsigned char *curAttr) {
/*
 char digits[]="0123456789ABCDEF";
 Tohleto  chce volat vnitrni pomocnou funkci N_SCOPY, takze prepsano jinak
*/
 unsigned int i,d;
 char digits[16];
 char c;

 i=0;
 for (c='0'; c<='F'; c++) {
  digits[i++]=c;
  if (c=='9') c='A'-1;
 }

 writeChar('0',curRow,curCol,curAttr); writeChar('x',curRow,curCol,curAttr);
 for (i=0; i<4; i++) {
  d=(x & 0xf000) >> 12;
  writeChar(digits[d],curRow,curCol,curAttr);
  x<<=4;
 }
}

void writeString(char* p,
  unsigned char *curRow, unsigned char *curCol, unsigned char *curAttr) {
 while (*p) { writeChar(*p,curRow,curCol,curAttr); p++; }
}


// Only %u (unsigned int - 2B), %l (unsigned long - 4B),
// %s (string - 2B NEAR ptr to string), %c (char - 1B),
// %i (signed int - 2B)
// and %x (hexa unsigned int - 2B) are supported.
// row,col are 0-based, upper left corner is [0,0]

void kprintf(unsigned char row, unsigned char col, unsigned char attr,
	     char* txt, ...)
{
 va_list va;
 char ch;
 int i;
 unsigned int u;
 unsigned long l;
 char* s;
 unsigned char curRow, curCol, curAttr;

 asm push es;

 curRow=row; if (curRow>24) curRow=0;
 curCol=col; if (curCol>79) curCol=0;
 curAttr=attr;

 va_start(va,txt);
 while (*txt) {
  if (*txt=='%') {
   if (*(txt+1)=='%') { writeChar('%',&curRow,&curCol,&curAttr); txt++; }
    else { switch (*(txt+1)) {
		  case 'u': u=va_arg(va,unsigned int); writeDecLong((unsigned long) u,&curRow,&curCol,&curAttr); break;
		  case 'i': i=va_arg(va,int); writeSignedDecInt(i,&curRow,&curCol,&curAttr); break;
		  case 'c': i=va_arg(va,int); writeChar((char)i,&curRow,&curCol,&curAttr); break;
		  case 'l': l=va_arg(va,unsigned long); writeDecLong(l,&curRow,&curCol,&curAttr); break;
		  case 's': s=va_arg(va,char*); writeString(s,&curRow,&curCol,&curAttr); break;
		  case 'x': u=va_arg(va,unsigned int); writeHexInt(u,&curRow,&curCol,&curAttr); break;
		  default:  writeChar('?',&curRow,&curCol,&curAttr);
	   }
	   txt++;
	 }
  } else
     writeChar(*txt,&curRow,&curCol,&curAttr);
  txt++;
 }
 va_end(va);
 asm pop es;
}