// TEST_PHASE 20
/* Test FS, ten docasne slinkovan s kernelem */
/* link, unlink */
// Written by P.G.

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"
#include "COMMON\callnr.h"
#include "COMMON\stat.h"

#include "test\kprintf.h"

#include "FS\COMMON\fsconst.h"
#include "FS\COMMON\fsmes.h"
#include "FS\CACHE\buf.h"

#include "lib\include\string.h"

#define PROC1 (NR_TASKS+NR_SERVS)


#define MK_FP( seg,ofs )( (void _seg * )( seg ) +( void near * )( ofs ))

static message m;

int dir(int line1) {
 /* prints the contents of the root dir */
 /* returns the number of directory entries */

 int fd;
 static struct dir_struct item;
 int entries=0;

 m.m_type = C_OPEN;
 m.fs_name = "/";
 m.fs_mode = S_IREAD;

 send_recv(FS,m);
 fd=m.fs_fd;
 if (fd<0) return fd;

 do {
   m.m_type = C_READ;
   m.fs_fd = fd;
   m.fs_buffer=(char*) (&item);
   m.fs_nbytes=sizeof (struct dir_struct);
   m.fs_seg=D;
   send_recv(FS,m);

   if (m.fs_errcode<0) return m.fs_errcode;
   if (m.fs_errcode==sizeof (struct dir_struct)) {
    if (item.d_inum!=0 && strcmp(item.d_name,".") && strcmp(item.d_name,".."))
     kprintf(line1+entries++,0,7,"%u : %s",item.d_inum,item.d_name);
   }
 } while (m.fs_errcode==sizeof (struct dir_struct));
 return entries;
}

void proc1(void) {

#define ORIGINAL_FILE "/file.1"
#define LINK_FILE "/file.lnk3"

 int fd,result,line=1;
 static unsigned char c;
 long l;

 m.m_type = C_CREAT;
 m.fs_name = ORIGINAL_FILE;
 m.fs_mode = I_REGULAR | 0777;
 send_recv(FS,m);
 fd=m.fs_fd;

 if (fd>=0) {
  kprintf(line++,0,7,"File " ORIGINAL_FILE  " created (file handle: %u)",fd);
  c=0;
  for (l=0; l<1024L; l++) {
   m.m_type = C_WRITE;
   m.fs_fd = fd;
   m.fs_buffer=&c;
   m.fs_nbytes=1;
   m.fs_seg=D;
   send_recv(FS,m);

   result=m.fs_errcode;
   if (result<0) {
    kprintf(line++,0,5,"Write error: %i",result);
    break;
   }
   c++;
  }
  kprintf(line++,0,7,"Test pattern of %l bytes written to the file",l);

  m.m_type = C_CLOSE;
  m.fs_fd = fd;
  send_recv(FS,m);
  kprintf(line++,0,7,"File closed. Close result: %i",m.fs_errcode);

  line+=dir(line);

  m.m_type = C_LINK;
  m.fs_name = ORIGINAL_FILE;
  m.fs_name2 = LINK_FILE;
  send_recv(FS,m);
  kprintf(line++,0,7,"File linked. Link result: %i",m.fs_errcode);

  line+=dir(line);

  m.m_type = C_UNLINK;
  m.fs_name = LINK_FILE;
  send_recv(FS,m);
  kprintf(line++,0,7,"File unlinked. Unlink result: %i",m.fs_errcode);

  line+=dir(line);
 }
  else kprintf(line++,0,7,"File creation error: %i",fd);

 m.m_type = C_SYNC;
 send_recv(FS,m);

 /* end with endless loop (the process must not exit, otherwise
    IP (PC) would get to some random place */

 while(1);
}

