// TEST_PHASE 21
/* Test FS, ten docasne slinkovan s kernelem */
/* create dir, chdir(), chroot() */
// Written by P.G.

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"
#include "COMMON\callnr.h"
#include "COMMON\stat.h"

#include "test\kprintf.h"

#include "FS\COMMON\fsconst.h"
#include "FS\COMMON\fsmes.h"
#include "FS\CACHE\buf.h"

#include "lib\include\string.h"

#define PROC1 (NR_TASKS+NR_SERVS)


#define MK_FP( seg,ofs )( (void _seg * )( seg ) +( void near * )( ofs ))

static message m;

int dir(char* dirName, int line1) {
 /* prints the contents of the root dir */
 /* returns the number of directory entries */

 int fd;
 static struct dir_struct item;
 int entries=0;

 m.m_type = C_OPEN;
 m.fs_name = dirName;
 m.fs_mode = S_IREAD;

 send_recv(FS,m);
 fd=m.fs_fd;
 if (fd<0) return fd;

 do {
   m.m_type = C_READ;
   m.fs_fd = fd;
   m.fs_buffer=(char*) (&item);
   m.fs_nbytes=sizeof (struct dir_struct);
   m.fs_seg=D;
   send_recv(FS,m);

   if (m.fs_errcode<0) return m.fs_errcode;
   if (m.fs_errcode==sizeof (struct dir_struct)) {
    if (item.d_inum!=0 && strcmp(item.d_name,".") && strcmp(item.d_name,".."))
     kprintf(line1+entries++,0,7,"%u : %s",item.d_inum,item.d_name);
   }
 } while (m.fs_errcode==sizeof (struct dir_struct));
 return entries;
}

#define DEPTH 'c'
#define FILE_MAX '1'

void proc1(void) {

 int fd,line=1,i;
 static unsigned char c,n;
 static char buf[10];

 for (c='a'; c<=DEPTH; c++) {

   m.m_type = C_CREAT;
   buf[0]=c; buf[1]=0; m.fs_name = buf;
   m.fs_mode = I_DIRECTORY | 0777;
   send_recv(FS,m);
   fd=m.fs_fd;
   if (fd<0) kprintf(line++,0,7,"Directory %c creation error: %i",c,fd);
    else {
      kprintf(line++,0,7,"Directory %c created",c);
      m.m_type = C_CLOSE;
      m.fs_fd = fd;
      send_recv(FS,m);
      if (m.fs_errcode!=0)
       kprintf(line++,0,7,"Directory %c close after creation error: %i",c,m.fs_errcode);
    }


   m.m_type = C_CHDIR;
   m.fs_name = buf;
   send_recv(FS,m);
   kprintf(line++,0,7,"chdir() to directory %c error code: %i",c,m.fs_errcode);

   buf[0]=c; buf[2]=0;
   for (n='0'; n<=FILE_MAX; n++) {
    m.m_type = C_CREAT;
    buf[1]=n; m.fs_name = buf;
    m.fs_mode = I_REGULAR | 0777;
    send_recv(FS,m);
    fd=m.fs_fd;
    if (fd<0) kprintf(line++,0,7,"File %s creation error",buf);
     else {
       kprintf(line++,0,7,"File %s created",buf);
       m.m_type = C_CLOSE;
       m.fs_fd = fd;
       send_recv(FS,m);
       if (m.fs_errcode!=0)
	kprintf(line++,0,7,"File %s close after creation error: %i",buf,m.fs_errcode);
     }
   }
 }

 n=0;
 for (c='a'; c<=DEPTH; c++) {
  buf[n++]='/'; buf[n++]=c; buf[n]=0;
  kprintf(line++,0,7,"Directory of %s:",buf);
  i=dir(buf,line);
  if (i>=0) line+=i;
   else kprintf(line++,0,7,"Directory read error: %i",i);
 }

 m.m_type = C_SYNC;
 send_recv(FS,m);

 /* end with endless loop (the process must not exit, otherwise
    IP (PC) would get to some random place */

 while(1);
}

