// TEST_PHASE 3
// Podobne jako TEST_PHASE 2, ale kazdy task pozaduje a ceka na alarm od clock
// tasku, aby tak vznikly prodlevy, ve kterych neni zadny task schopen behu.
// Na to navaze dalsi test, ktery prida uzivatelske procesy, planovane prave
// v techto prodlevach.
// Written by P.G.

// MUSI BYT NASMEROVANO INT 08

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"
#include "clock\h_clock.h"

/* v inicialni fronte planovace v tomto poradi */
#define TASK1 2
#define TASK2 3
#define TASK3 4

#define MK_FP( seg,ofs )( (void _seg * )( seg ) +( void near * )( ofs ))

static message m1,m2,m3,am1,am2,am3;

// alarm fce bezi v kontextu clock tasku
void task1_alarm_func(int nanic) {
 send(TASK1,m1);
}

void task2_alarm_func(int nanic) {
 send(TASK2,m2);
}

void task3_alarm_func(int nanic) {
 send(TASK3,m3);
}


void task1(void) {
 char far* pos=(char far*) MK_FP(0xb800,5*80*2+40*2);
 do {
   *pos='|';
   am1.m_type=SET_ALARM;
   am1.CLOCK_PROC=TASK1;
   am1.FUNC=(sighandler_t) task1_alarm_func;
   am1.NEW_TIME=3;
   send_recv(CLOCK,am1);
   if (am1.RET_ERROR_CODE!=OK) {
     char far* p=(char far*) MK_FP(0xb800,6*80*2+42*2);
     *p='!';
   }
   receive(CLOCK,m1); // alarm fce bezi v kontextu clock tasku
		      // odsud se dostanu az po ohlaseni alarmu
 } while(1);
}


void task2(void) {
 char far* pos=(char far*) MK_FP(0xb800,5*80*2+40*2);

 am2.m_type=SET_ALARM;
 am2.CLOCK_PROC=TASK2;
 am2.FUNC=(sighandler_t) task2_alarm_func;
 am2.NEW_TIME=1;
 send_recv(CLOCK,am2);
 if (am2.RET_ERROR_CODE!=OK) {
   char far* p=(char far*) MK_FP(0xb800,6*80*2+43*2);
   *p='!';
 }
 receive(CLOCK,m2); // alarm fce bezi v kontextu clock tasku
		    // odsud se dostanu az po ohlaseni alarmu
 do {
   *pos='/';
   am2.m_type=SET_ALARM;
   am2.CLOCK_PROC=TASK2;
   am2.FUNC=(sighandler_t) task2_alarm_func;
   am2.NEW_TIME=3;
   send_recv(CLOCK,am2);
   if (am2.RET_ERROR_CODE!=OK) {
     char far* p=(char far*) MK_FP(0xb800,6*80*2+43*2);
     *p='!';
   }
   receive(CLOCK,m2); // alarm fce bezi v kontextu clock tasku
		      // odsud se dostanu az po ohlaseni alarmu
 } while(1);
}

void task3(void) {
 char far* pos=(char far*) MK_FP(0xb800,5*80*2+40*2);

 am3.m_type=SET_ALARM;
 am3.CLOCK_PROC=TASK3;
 am3.FUNC=(sighandler_t) task3_alarm_func;
 am3.NEW_TIME=2;
 send_recv(CLOCK,am3);
 if (am3.RET_ERROR_CODE!=OK) {
   char far* p=(char far*) MK_FP(0xb800,6*80*2+43*2);
   *p='!';
 }
 receive(CLOCK,m3); // alarm fce bezi v kontextu clock tasku
		    // odsud se dostanu az po ohlaseni alarmu
 do {
   *pos='-';
   am3.m_type=SET_ALARM;
   am3.CLOCK_PROC=TASK3;
   am3.FUNC=(sighandler_t) task3_alarm_func;
   am3.NEW_TIME=3;
   send_recv(CLOCK,am3);
   if (am3.RET_ERROR_CODE!=OK) {
     char far* p=(char far*) MK_FP(0xb800,6*80*2+43*2);
     *p='!';
   }
   receive(CLOCK,m3); // alarm fce bezi v kontextu clock tasku
		      // odsud se dostanu az po ohlaseni alarmu
 } while(1);
}

