// TEST_PHASE 5
/* Test blokovych zarizeni. Nejprve zjisteni informaci o podporovanych
   minor zarizenich a jejich velikostech. */
// Written by P.G.

// MUSI BYT NASMEROVANO INT 08 a INT0E

#define BDEV_TO_TEST FLOPPY
 // which block device to test

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"
#include "fs\ioctl.h"
#include "test\kprintf.h"

#define SERV1 NR_TASKS

static char buf[BLOCK_SIZE];

static message m;

// na pozici 1.serveru
void serv1(void) {
 static int devs;
 static long blocks;
 int i,match;
 char c;

 m.m_type=DEV_IOCTL;
 m.m_u.m_dio.device=0; /* aby to driver neodmitnul */
 m.m_u.m_dio.count=GETNUMBERMINORDEV;
 m.m_u.m_dio.proc_nr=SERV1;
 m.m_u.m_dio.address=(vir_bytes) (&devs);

 send_recv(BDEV_TO_TEST,m);
 if (m.REP_STATUS!=OK)
  kprintf(1,0,7,"Error reply to GETNUMBERMINORDEV (%i), exiting",m.REP_STATUS);
 else {
  kprintf(0,0,7,"Number of minor devices: %i",devs);
  for (i=0; i<devs; i++) {
   m.m_type=DEV_IOCTL;
   m.m_u.m_dio.device=i;
   m.m_u.m_dio.count=GETDEVSIZE;
   m.m_u.m_dio.proc_nr=SERV1;
   m.m_u.m_dio.address=(vir_bytes) (&blocks);

   send_recv(BDEV_TO_TEST,m);
   if (m.REP_STATUS==OK)
    kprintf(5+i,0,7,"Minor device %u has %l blocks",i,blocks);
   else
    kprintf(5+i,0,7,"Minor device %u: Error reply to GETDEVSIZE (%i)",i,m.REP_STATUS);
  }
 }
 if (devs>0 && blocks>0) {

   c=0;
   for (i=0; i<BLOCK_SIZE; i++,c++) buf[i]=c;

   m.m_type=DEV_WRITE;
   m.m_u.m_dio.device=0;
   m.m_u.m_dio.count=1;
   m.m_u.m_dio.position=0;
   m.m_u.m_dio.proc_nr=SERV1;
   m.m_u.m_dio.address=(vir_bytes) buf;

   send_recv(BDEV_TO_TEST,m);
   kprintf(7,0,7,"WRITE RESULT: %i",m.REP_STATUS);

   // destroy data in buffer
   for (i=0; i<BLOCK_SIZE; i++) buf[i]=0;

   c=0; match=1;
   for (i=0; i<BLOCK_SIZE; i++,c++) if (buf[i]!=c) { match=0; break; }
   kprintf(9,0,7,"After buffer destroy: COMPARE RESULT: %i",match);

   m.m_type=DEV_READ;
   m.m_u.m_dio.device=0;
   m.m_u.m_dio.count=1;
   m.m_u.m_dio.position=0;
   m.m_u.m_dio.proc_nr=SERV1;
   m.m_u.m_dio.address=(vir_bytes) buf;

   send_recv(BDEV_TO_TEST,m);
   kprintf(8,0,7,"READ RESULT: %i",m.REP_STATUS);

   c=0; match=1;
   for (i=0; i<BLOCK_SIZE; i++,c++) if (buf[i]!=c) { match=0; break; }
   kprintf(10,0,7,"After read: COMPARE RESULT: %i",match);

 }

 while(1);
}


