// TEST_PHASE 64
/* Test MM, ten docasne slinkovan s kernelem */
/* test setpgrp, getpgrp, getpid, getppid, getuid, setuid, getgid, setgid */
// Written by P.G.

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"
#include "COMMON\callnr.h"
#include "test\kprintf.h"
#include "test\exitor.h"
#include "mm\mm.h"

static message m;
int line=0;

void separator(void)
{
 kprintf(line++,0,7,"----------------------------------");
}

void proc1(void) {

/* --------------------- getpgrp(), setpgrp() ------------------------- */

 m.m_type = C_GETPGRP;
 m.MM_GPGRPPID=0; /* tento proces */
 send_recv(MM,m);
 if (m.MM_ERRORNO==0) {
   kprintf(line++,0,7,"getpgrp() returned: %u",m.MM_PGRP);

   m.m_type = C_SETPGRP;
   m.MM_SPGRPPID=0; /* tento proces */
   m.MM_SPGRPVALUE=1234;
   send_recv(MM,m);
   if (m.MM_ERRORNO==0) {
     kprintf(line++,0,7,"setpgrp(1234)");
     m.m_type = C_GETPGRP;
     m.MM_GPGRPPID=0; /* tento proces */
     send_recv(MM,m);
     if (m.MM_ERRORNO==0) kprintf(line++,0,7,"verification: getpgrp() returned: %u",m.MM_PGRP);
      else kprintf(line++,0,7,"getpgrp() failed: %i",m.MM_ERRORNO);
   }
    else kprintf(line++,0,7,"setpgrp() failed: %i",m.MM_ERRORNO);
  }
  else kprintf(line++,0,7,"getpgrp() failed: %i",m.MM_ERRORNO);

/* ------------------------ getpid()/getppid() ------------------------- */
 separator();

 m.m_type = C_GETPID;
 send_recv(MM,m);
 if (m.MM_ERRORNO==0) kprintf(line++,0,7,"getpid(): PID=%u, PPID=%u",m.MM_GPID,m.MM_GPPID);
  else kprintf(line++,0,7,"getpid() failed: %i",m.MM_ERRORNO);

/* ------------------------ getuid()/setuid() --------------------------- */
 separator();

 m.m_type = C_GETUID;
 m.MM_GETIDPID=0; /* uid tohoto procesu */
 send_recv(MM,m);
 if (m.MM_ERRORNO==0)
  kprintf(line++,0,7,"getuid(): effective uid: %u, real uid: %u",m.MM_GEUID,m.MM_GRUID);
 else kprintf(line++,0,7,"getuid() failed: %i",m.MM_ERRORNO);

 /* predpoklada se, ze jsme root a smime provadet setuid() */
 m.m_type = C_SETUID;
 m.MM_SUID=4321;
 send_recv(MM,m);
 if (m.MM_ERRORNO!=0) kprintf(line++,0,7,"setuid() failed: %i",m.MM_ERRORNO);
  else {
	kprintf(line++,0,7,"setuid(4321)");
	m.m_type = C_GETUID;
	m.MM_GETIDPID=0; /* uid tohoto procesu */
	send_recv(MM,m);
	if (m.MM_ERRORNO==0)
	 kprintf(line++,0,7,"verification: getuid(): effective uid: %u, real uid: %u",m.MM_GEUID,m.MM_GRUID);
	  else kprintf(line++,0,7,"getuid() failed: %i",m.MM_ERRORNO);
       }

/* ------------------------ getgid()/setgid() --------------------------- */
 separator();

 m.m_type = C_GETGID;
 m.MM_GETIDPID=0; /* uid tohoto procesu */
 send_recv(MM,m);
 if (m.MM_ERRORNO==0)
  kprintf(line++,0,7,"getgid(): effective gid: %u, real gid: %u",m.MM_GEGID,m.MM_GRGID);
 else kprintf(line++,0,7,"getgid() failed: %i",m.MM_ERRORNO);

 /* predpoklada se, ze jsme root a smime provadet setuid() */
 m.m_type = C_SETGID;
 m.MM_SUID=210;
 send_recv(MM,m);
 if (m.MM_ERRORNO!=0) kprintf(line++,0,7,"setgid() failed: %i",m.MM_ERRORNO);
  else {
	kprintf(line++,0,7,"setgid(210)");
	m.m_type = C_GETGID;
	m.MM_GETIDPID=0; /* uid tohoto procesu */
	send_recv(MM,m);
	if (m.MM_ERRORNO==0)
	 kprintf(line++,0,7,"verification: getgid(): effective gid: %u, real gid: %u",m.MM_GEGID,m.MM_GRGID);
	  else kprintf(line++,0,7,"getgid() failed: %i",m.MM_ERRORNO);
       }


 returnToDOS();
}

