// TEST_PHASE 71
/* Test MM, ten docasne slinkovan s kernelem */
/* test signal, alarm, pause */
// Written by P.G.

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"
#include "COMMON\callnr.h"
#include "test\kprintf.h"
#include "test\exitor.h"
#include "mm\mm.h"
#include "COMMON\signal.h"

static message m;
static int activCount=0;

void signalHandlerInLib(int sigNo);

void setAlarm(int sec) {

 m.m_type = C_SIGNAL;
 m.MM_SIGNAL=SIGALRM;
 m.MM_PTRFUNC=signalHandlerInLib;

 send_recv(MM,m);
 if (m.MM_ERRORNO!=0) {
      kprintf(1,0,7,"signal() error: %i",m.MM_ERRORNO);
      returnToDOS();
 }

 m.m_type=C_ALARM;
 m.MM_ALARMSECOND=sec;
 send_recv(MM,m);

 if (m.MM_ERRORNO!=0) {
      kprintf(1,0,7,"alarm() error: %i",m.MM_ERRORNO);
      returnToDOS();
 }
}

int getpid(int* pid, int* ppid) {
 m.m_type = C_GETPID;
 send_recv(MM,m);
 if (m.MM_ERRORNO==0) { *pid=m.MM_GPID; *ppid=m.MM_GPPID; }
 return m.MM_ERRORNO;
}

void signalHandlerInLib(int sigNo) {
 /* push bp
    mov bp,sp */

  asm {
   push ax
   push bx
   push cx
   push dx
   push si
   push di
  }
  kprintf(2,0,7,"Signal handler activated (%u)",sigNo);
  asm {
   pop di
   pop si
   pop dx
   pop cx
   pop bx
   pop ax

   pop bp
   add sp,8 /* za si,di (schovava prekladac), fiktivni navratovou adresu
	       (near) a signal# */
   iret
  }
}

void proc1(void) {
 int err,pid,ppid;


 /* zjisti svuj PID */

 if (getpid(&pid,&ppid)) {
      kprintf(1,0,7,"getpid() error: %i",m.MM_ERRORNO);
      returnToDOS();
 }

 kprintf(1,0,7,"PID %u: signal handler installed. Calling alarm(1)...",pid);

 setAlarm(1);

 kprintf(3,0,7,"After signal() and alarm(). Calling pause()...");

 m.m_type = C_PAUSE;
 send_recv(MM,m);

 kprintf(4,0,7,"After pause()...");
 returnToDOS();
}

