/*===========================================================================*
 *                               Terminal Task                               *
 *===========================================================================*
 * Written by : Martin Bajgar                                                *
 * Last update: 04-06-1997                                                   *
 *===========================================================================*/

/*===========================================================================*
 *                              do_charint                                   *
 *===========================================================================*/
/*
 Character (or more, which could not be reported before) has been typed.

 Pripojime znaky do vstupni fronty prislusneho zarizeni

 Smycka pres vsechny znaky ve fronte (odkaz na ni v m_ptr, ale je to tty_driver_buf[])
 Protoze v dobe zpracovavani znaku fronty muhou byt generovany dalsi znaky,
 musime nejprve tty_driver_buf pri zakazanem preruseni zkopirovat jinam
 a jej prohlasit za prazdny; az pak povolit preruseni a dodelat pruchod
 smyckou

  in_char(ch); - interpretuj znak, uloz do fronty a echo
  Zjisti, jestli muze byt uspokojen nejaky proces cekajici na vstup
   pri (CBREAK or RAW) nebo lfcount>0
    => zformuj zpravu REVIVE a odpovez (komu a jmenem koho najdes v tty_struct[])
*/

// zpracovani zpravy charint
PRIVATE void do_charint(void)
{
	struct tty_driver_buf_struct buffer;  // sem si zkopirujeme buffer
					      // klavesnice 'tty_driver_buf'
	struct tty_struct *tp;
        int i, count;

	// kopiruj pole ...
	asm cli
	count = tty_driver_buf.count; buffer.count = count;
	for (i=0; i<count; i++) {
	    buffer.terminal_nr[i] = tty_driver_buf.terminal_nr[i];
	    buffer.code[i]        = tty_driver_buf.code[i];
	}
	tty_driver_buf.count = 0; // vyprazdni vstupnim buffer
	asm sti

	// pruchod pres vsechny znaky ve fronte, volej in_char()
	for (i = 0; i < count; i++) {
	    in_char(buffer.terminal_nr[i], buffer.code[i]);
	}

	// zjisti zda je mozno nokoho uspokojit, pokud ano posli revive
	for (i = 0; i < NR_TTYS; i++)
	{
		tp = tty_addr(i);

		if (tp->tty_inleft > 0)
		{
			if (tp->tty_discipline == COOKED)
			{
				if (tp->tty_lfcount > 0)
				{

				 task_reply(_C_REVIVE,transfer(tp), tp->tty_incaller, tp->tty_inproc);
				 tp->tty_inleft = 0;
				}
			}
			else
			{
				if (tp->tty_incount > 0)
				{

				 task_reply(_C_REVIVE,transfer(tp), tp->tty_incaller, tp->tty_inproc);
				 tp->tty_inleft = 0;
				}
			}
		}
	}
}
