/*===========================================================================*
 *                               Terminal Task                               *
 *===========================================================================*
 * Written by : Rongi                                                        *
 * Last update: 27-05-1997                                                   *
 *===========================================================================*/

/*===========================================================================*
 *                              make_break                                   *
 *===========================================================================*/
/*
 Prepocet scan kodu na ASCII (podle typu klavesnice) a nastaveni
 globalnich promennych udrzujici stavy ruznych shiftu.
 Pokud klavesnice generuje preruseni i pri uvolneni klavesy,
 pouze vrat 0
*/

/*
stav: funkcni
dodelat: kontrola tabulek, prepoctu
	 dopsat do tabulek hodnoty pro klavesy, ktere se neignoruji (Del, ...)
	 odstranit debug funkce (nevolaji se)
*/

/* prevodni tabulky */
extern char scan2ascii[];
extern char scan2ascii_shifted[];
extern char scan2ascii_numlocked[];

void make_break_debug(void);

/* constants for key_flag */
#define FLAG_SHIFT           0x01
#define FLAG_CTRL            0x02
#define FLAG_ALT             0x04
#define FLAG_NUM_LOCK        0x08
#define FLAG_CAPS_LOCK       0x10
/* #define FLAG_SCROLL_LOCK     0x20 */

PRIVATE unsigned int key_flag=0;

PRIVATE char make_break(unsigned char ch)
{
 char res=0;
 char tmp;
 if (ch & BREAK_CODE)   /* pusteni klavesy */
  {
   ch &= ~BREAK_CODE;
   switch(ch)
    {
     case sc_LShift: key_flag &= ~FLAG_SHIFT; break;
     case sc_RShift: key_flag &= ~FLAG_SHIFT; break;
     case sc_Ctrl:   key_flag &= ~FLAG_CTRL;  break;
     case sc_Alt:    key_flag &= ~FLAG_ALT;   break;
    }
   // make_break_debug();
   return 0;
  }

 switch(ch)
  {
   case sc_LShift:      key_flag |= FLAG_SHIFT; break;
   case sc_RShift:      key_flag |= FLAG_SHIFT; break;
   case sc_Ctrl:        key_flag |= FLAG_CTRL;  break;
   case sc_Alt:         key_flag |= FLAG_ALT;   break;

   case sc_NumLock:     key_flag ^= FLAG_NUM_LOCK;      break;
   case sc_CapsLock:    key_flag ^= FLAG_CAPS_LOCK;     break;
/*   case sc_ScrollLock:  key_flag ^= FLAG_SCROLL_LOCK;   break; */

   default:
     if (key_flag & FLAG_ALT)
       return 0;
     if (key_flag & FLAG_CTRL)
      {
       tmp = scan2ascii_shifted[ch];
       if (tmp >= '@' && tmp <= 'Z')
	 res = tmp - '@';
       else if (tmp >= '{' && tmp <= '}')
	 res = tmp - '{' + 0x1b;
      }
     else
      {
       if (key_flag & FLAG_NUM_LOCK && ch >= sc_Home)
	 res = scan2ascii_numlocked[ch];
       else
	{
	 if (key_flag & FLAG_SHIFT)
	  {
	   res = scan2ascii_shifted[ch];
	   if (key_flag & FLAG_CAPS_LOCK && res >= 'A' && res <= 'Z')
	     res += 'a' - 'A';
	  }
	 else
	  {
	   res = scan2ascii[ch];
	   if (key_flag & FLAG_CAPS_LOCK && res >= 'a' && res <= 'z')
	     res -= 'a' - 'A';
	  }
	}
      }
  }

 // make_break_debug();
 return res;
}

char scan2ascii[] =
/* 0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F   */

 { 0,  27, '1','2','3','4','5','6','7','8','9','0','-','=',8,  9,     /* 0 */
   'q','w','e','r','t','y','u','i','o','p','[',']',13, 0,  'a','s',   /* 1 */
   'd','f','g','h','j','k','l',';','\'','`',0,'\\','z','x','c','v',   /* 2 */
   'b','n','m',',','.','/',0,  '*',0,  ' ',0,  0,  0,  0,  0,  0,     /* 3 */
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  '-',0,  0,  0,  '+',0,     /* 4 */
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     /* 5 */
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     /* 6 */
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 };   /* 7 */

char scan2ascii_shifted[] =
/* 0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F   */

 { 0,  27, '!','@','#','$','%','^','&','*','(',')','_','+',8,  9,     /* 0 */
   'Q','W','E','R','T','Y','U','I','O','P','{','}',13, 0,  'A','S',   /* 1 */
   'D','F','G','H','J','K','L',':','"','~',0,  '|','Z','X','C','V',   /* 2 */
   'B','N','M','<','>','?',0,  '*',0,  ' ',0,  0,  0,  0,  0,  0,     /* 3 */
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  '-',0,  0,  0,  '+',0,     /* 4 */
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     /* 5 */
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     /* 6 */
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 };   /* 7 */


char scan2ascii_numlocked[] =
/* 0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F   */

 { 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     /* 0 */
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     /* 1 */
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     /* 2 */
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     /* 3 */
   0,  0,  0,  0,  0,  0,  0,'7','8','9','-','4','5','6','+','1',     /* 4 */
 '2','3','0','.',  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     /* 5 */
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,     /* 6 */
   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 };   /* 7 */


/*
Values for keyboard make/break (scan) code:
 01h    Esc              31h    N
 02h    1 !              32h    M
 03h    2 @              33h    , <              63h    F16
 04h    3 #              34h    . >              64h    F17
 05h    4 $              35h    / ?              65h    F18
 06h    5 %              36h    Right Shift      66h    F19
 07h    6 ^              37h    Grey*            67h    F20
 08h    7 &              38h    Alt              68h    F21
 09h    8 *              39h    SpaceBar         69h    F22
 0Ah    9 (              3Ah    CapsLock         6Ah    F23
 0Bh    0 )              3Bh    F1               6Bh    F24
 0Ch    - _              3Ch    F2               6Ch    --
 0Dh    = +              3Dh    F3               6Dh    EraseEOF
 0Eh    Backspace        3Eh    F4
 0Fh    Tab              3Fh    F5               6Fh    Copy/Play
 10h    Q                40h    F6
 11h    W                41h    F7
 12h    E                42h    F8               72h    CrSel
 13h    R                43h    F9               73h    <delta> [*]
 14h    T                44h    F10              74h    ExSel
 15h    Y                45h    NumLock          75h    --
 16h    U                46h    ScrollLock       76h    Clear
 17h    I                47h    Home
 18h    O                48h    UpArrow
 19h    P                49h    PgUp
 1Ah    [ {              4Ah    Grey-
 1Bh    ] }              4Bh    LeftArrow
 1Ch    Enter            4Ch    Keypad 5
 1Dh    Ctrl             4Dh    RightArrow
 1Eh    A                4Eh    Grey+
 1Fh    S                4Fh    End
 20h    D                50h    DownArrow
 21h    F                51h    PgDn
 22h    G                52h    Ins
 23h    H                53h    Del
 24h    J                54h    SysReq          ---non-key codes---
 25h    K                                        00h    kbd buffer full
 26h    L                56h    left \| (102-key)
 27h    ; :              57h    F11              AAh    self-test complete
 28h    ' "              58h    F12              E0h    prefix code
 29h    ` ~                                      E1h    prefix code
 2Ah    Left Shift       5Ah    PA1              EEh    ECHO
 2Bh    \ |              5Bh    F13 (LWin)       F0h    prefix code (key break)
 2Ch    Z                5Ch    F14 (RWin)       FAh    ACK
 2Dh    X                5Dh    F15 (Menu)       FCh    diag failure (MF-kbd)
 2Eh    C                                        FDh    diag failure (AT-kbd)
 2Fh    V                                        FEh    RESEND
 30h    B                                        FFh    kbd error/buffer full
Notes:  scan codes 56h-E1h are only available on the extended (101/102-key)
	  keyboard and Host Connected (122-key) keyboard; scan codes 5Bh-5Dh
	  are only available on the 122-key keyboard and the Microsoft Natural
	  Keyboard; scan codes 5Eh-76h are only available on the 122-key
	  keyboard
	in the default configuration, break codes are the make scan codes with
	  the high bit set; make codes 60h,61h,70h, etc. are not available
	  because the corresponding break codes conflict with prefix codes
	  (code 2Ah is available because the self-test result code AAh is only
	  sent on keyboard initialization).  An alternate keyboard
	  configuration can be enabled on AT and later systems with enhanced
	  keyboards, in which break codes are the same as make codes, but
	  prefixed with an F0h scan code
	prefix code E0h indicates that the following make/break code is for a
	  "gray" duplicate to a key which existed on the original PC keyboard;
	  prefix code E1h indicates that the following make code has no
	  corresponding break code (currently only the Pause key generates no
	  break code)
	the Microsoft Natural Keyboard sends make codes 5Bh, 5Ch, and 5Dh
	  (all with an E0h prefix) for the Left Windows, Right Windows, and
	  Menu keys on the bottom row
	the German "Cherry G81-3000 SAD/04" keyboard contains contacts for
	  four additional keys, which can be made available by a user
	  modification; the three new keys located directly below the cursor
	  pad's Delete, End, and PgDn keys send make codes 66h-68h (F19-F21);
	  the fourth new key, named <delta>, sends make code 73h
	the SysReq key is often labeled SysRq
*/

#ifdef DEBUG
void make_break_debug(void)
{
 if (key_flag & FLAG_SHIFT)
   put_char(5, 24, 'S'+0x0200);
 else
   put_char(5, 24, 's'+0x0200);
 if (key_flag & FLAG_CTRL)
   put_char(6, 24, 'C'+0x0200);
 else
   put_char(6, 24, 'c'+0x0200);
 if (key_flag & FLAG_ALT)
   put_char(7, 24, 'A'+0x0200);
 else
   put_char(7, 24, 'a'+0x0200);

 if (key_flag & FLAG_NUM_LOCK)
   put_char(10, 24, 'N'+0x0400);
 else
   put_char(10, 24, 'n'+0x0400);
 if (key_flag & FLAG_CAPS_LOCK)
   put_char(11, 24, 'C'+0x0400);
 else
   put_char(11, 24, 'c'+0x0400);
}
#endif
