/*===========================================================================*
 *                               Terminal Task                               *
 *===========================================================================*
 * Written by : Rongi                                                        *
 * Last update: 07-05-1997                                                   *
 *===========================================================================*

   This is a PUBLIC part of our TTY header. Enjoy it!
*/

#if !defined __TTY_COM_H
#define __TTY_COM_H

PUBLIC void tty_task(void);
PUBLIC void keyboard(void);

#define CONSOLE            0    // index of console in tty_table
#define RS232LINE1         1    // index of console in tty_table
#define RS232LINE2         2    // index of console in tty_table

// Rizeni modu terminalu.
// message->m_type = DEV_IOCTL
// message->m_request = jedna z techto 4 hodnot:
#define TIOCSETP 1 // nastaveni paranetru tty
#define TIOCSETC 2 // nastaveni ridicich znaku tty
#define TIOCGETP 3 // cteni paranetru tty
#define TIOCGETC 4 // cteni ridicich znaku tty
#define SETRS232 5 //nastaveni parametru prenosu

// message->m_address ukazuje na jednu z techto struktur:
// nastaveni/cteni parametru terminalu
struct tty_params{
  char tty_erase;
  char tty_kill;
  int  tty_mode;
  int  tty_discipline;
};

struct rs232_params{
  int stop_bity;
  int rychlost_prenosu;
  int parita;
};


// nastaveni/cteni ridicich znaku terminalu
struct tty_ctrlchars{
  char tty_intr;
  char tty_quit;
  char tty_xon;
  char tty_xoff;
  char tty_eof;
};

#endif

